/* $Id: wmain.c,v 1.20 1999/01/31 19:35:37 fzk Exp $ */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include <math.h>
#define DEFINECONSTANTS
#include "wuerfel.h"

int main(int argc, char **argv) {

    WG *wg;            /* der Wuerfelguertel */
    int anzelt;        /* Anzahl Elemente im Wrfelgrtel */
    OPTIONS options;

    ident();
    getoptions (argc, argv, &options);

    wg = berechnewg(options, &anzelt);

    if (options.print) {
	printf ("Datenfiles enthalten %d Positionen des Wrfelgrtels\n",
		anzelt);
    }
    else {
	control ();
	zeichnewg(&options, wg);
    }

    freewg(wg);

    return 0;
}

void
ident (void) {
    fprintf (stderr, "Der umstuelpbare Wuerfel nach Paul Schatz\n");
    fprintf (stderr, "(C) 1999 Franz Zahaurek <http://www.fzk.at>\n");
}

void
usage (void) {
    fprintf (stderr, "\n");
    fprintf (stderr, "Optionen: -a     Achsen darstellen\n");
    fprintf (stderr, "          -b #   Breite des Fensters in Pixeln, Default=1/2 BS-Breite\n");
    fprintf (stderr, "          -e     Linien zum Evolutions- und Involutionspunkt darstellen\n");
    fprintf (stderr, "          -h     Hilfetext ausgeben\n");
    fprintf (stderr, "          -p     nur Koordinaten der Punkte ausgeben\n");
    fprintf (stderr, "          -w #   Schrittweite in Grad, Default=6 Grad\n");
}

void
control (void) {
    fprintf (stderr, "\n");
    fprintf (stderr, "Steuerung: -/+   schneller/langsamer drehen\n");
    fprintf (stderr, "           s     Toggle: start/stopp\n");
    fprintf (stderr, "           u/v/w Drehung um die u/v/w-Achse\n");
    fprintf (stderr, "           0     Drehung um u/v/w-Achse auf 0 stellen\n");
    fprintf (stderr, "           e     Toggle: Linien zu E/I zeigen/verbergen\n");
    fprintf (stderr, "           a     Toggle: Achsen zeigen/verbergen\n");
    fprintf (stderr, "           q     Quit\n\n");
}

void
warten (int sec){
    fd_set rfds;
    struct timeval tv;

    /* Watch stdin (fd 0) to see when it has input. */
    FD_ZERO(&rfds);
    FD_SET(0, &rfds);
    /* Wait up to sec seconds. */
    tv.tv_sec = sec;
    tv.tv_usec = 0;

    select(1, &rfds, NULL, NULL, &tv);
}

void
getoptions (int argc, char **argv, OPTIONS *retopt) {
    OPTIONS options;
    int c;
    extern int optind;

    optind = 1;
 
    options.dw = 0;
    options.seite = 0;
    options.print = FALSE;
    options.ei = FALSE;
    options.ach = FALSE;

    while (TRUE) {
	extern int opterr, optopt;
	opterr = 0;

	c = getopt (argc, argv, "aehb:pw:");
/* 	fprintf (stderr, "getopt: c=%d, opterr=%d, optopt=%c, optarg=%s\n", */
/* 		 c, opterr, optopt, optarg); */
	if ( c == -1) {
	    break;
	}

	switch (c) {
	case -1:
	    break;

	case 'w':
/* 	    fprintf (stderr, "Option w with value '%s'", optarg); */
	    options.dw = (BWINKEL)((double)atoi (optarg) * M_PI / 180);
	    break;

	case 'b':
/* 	    fprintf (stderr, "Option b with value '%s'", optarg); */
	    options.seite = atoi (optarg);
	    break;

	case 'p':
/* 	    fprintf (stderr, "Option p set\n"); */
	    options.print = TRUE;
	    break;

	case 'e':
	    fprintf (stderr, "Option e set\n");
	    options.ei = TRUE;
	    break;

	case 'a':
/* 	    fprintf (stderr, "Option a set\n"); */
	    options.ach = TRUE;
	    break;

	case 'h':
	    usage ();
	    exit (1);

	default:
	    fprintf (stderr, "\n");
	    fprintf (stderr, "Falsche Option oder fehlerhaftes Optionsargument: <%c>\n", optopt);
	    usage ();
	    exit (1);
	}
    }
    memcpy (retopt, &options, sizeof(OPTIONS));
}
